



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Single linked List by pointer</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Single linked List by pointer</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-28 19:49:05 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<div>
<p>其实本应该从一般性的表讲起的，先说顺序表，再说链表 。但顺序表的应用范围不是很广，而且说白了就是数组的高级版本，他的优势仅在于两点：1.逻辑直观，易于理解。2.查找某个元素只需要常数时间——O(1)，而与此同时，因为每个单元的物理内存都是连续的，所以不便于移动，不便于精细化操作，每次插入和删除都会带来巨额的时间开销。什么叫“巨额时间开销”？&nbsp; 举个栗子：我要在开头加一个数进去，那我要把所有的元素都往后移一位，空出来一个位置，这就需要穿过整个表，假如这个表有1000万个元素，大家可以自己脑补一下要花多久，答案是O(n)。这是时间的浪费。而如果用来计算稀疏多项式，比如：x^100+x^1300+x，这会造成中间有很多存储单元里存的是0，没有任何意义，但却实实在在消耗了内存，这是空间浪费。</p>
<p>因为插入和删除的运行时间非常慢，而且表的大小还必须事先已知，所以一般不用简单数组来实现表这种结构。</p>
<p><img referrerpolicy="no-referrer"src="http://images2017.cnblogs.com/blog/1262741/201710/1262741-20171023211112769-1026840690.jpg"></p>
<p>现在我们需要一种灵活的方法来使我们突破连续储存带来的限制，那怎么办呢？就不连续储存呗，把空间离散化。每一个单元里面大体分为两部分，一边存数据，另一边存下一个单元的地址，这样一来，逻辑上仍然是连续的，而在物理内存中则是星罗棋布了。这就是我们要学的链表了。这是我们要学的第一种线性结构。</p>
<p>现在，我们要加入或者移除一个元素的时候，就不必担心会对全体数据造成影响了，只需要改动“链条”就好了，其他不变。这样就能减少增删的时间开销了。单链表的样子就像这样：</p>
<p><img referrerpolicy="no-referrer"src="http://images2017.cnblogs.com/blog/1262741/201710/1262741-20171023211124473-2112743691.png"></p>
<p>可以脑补一列火车车厢hhhhhh</p>
<p><img referrerpolicy="no-referrer"src="https://ss1.bdstatic.com/70cFvXSh_Q1YnxGkpoWK1HF6hhy/it/u=3902248867,3523671754&amp;fm=27&amp;gp=0.jpg"></p>
<p>当然火车车厢是双链表，我们现在简便起见，先介绍单链表。</p>
<p>删除的命令可以通过修改一个指针来实现，就像这样：</p>
<p><img referrerpolicy="no-referrer"src="http://images2017.cnblogs.com/blog/1262741/201710/1262741-20171023211154660-659841891.png"></p>
<p>插入的话，我们需要申请一个新单元，怎么申请？printf("请给我一点内存，谢谢")；</p>
<p>显然不是的，对吧。那该怎么做？</p>
<p><img referrerpolicy="no-referrer"src="http://images2017.cnblogs.com/blog/1262741/201710/1262741-20171023211538144-1677766223.jpg"></p>
<p>对！malloc函数，说到这个，我多说几句啊。首先，别拼错了，我之前会手滑打错，也遇到过记不住这个函数名字的小白，咱得记住它的意思“Memory Allocate“，内存分配，这个内存从哪分配的呢，总不会是操作系统凭空变出来的，它是从“堆（Heap）”上分配来的，这个堆也是我们以后要学的一种数据结构。</p>
<p>接着说插入，申请一个新单元之后，我们再做两次指针调整就好了，就像这样：</p>
<p><img referrerpolicy="no-referrer"src="http://images2017.cnblogs.com/blog/1262741/201710/1262741-20171023211600316-171731694.png"></p>
<p>重点：整个链表的核心在于指针的调整，而首先，我们要“拉住”整个链表，也就是说我们需要一个引子，来牵住整个一长串的表，这个引子就相当于火车头。因为每一个单元的物理位置都是随机的，想找到下一个只能依靠前一个单元的尾针（毕竟这是单链表）。</p>
<p><img referrerpolicy="no-referrer"src="http://images2017.cnblogs.com/blog/1262741/201710/1262741-20171023212002176-1297563098.png">操作指针时一定要小心，包括调整顺序和指向。否则就会像这样</p>
<p><img referrerpolicy="no-referrer"src="http://images2017.cnblogs.com/blog/1262741/201710/1262741-20171023211629160-1088261725.jpg"></p>
<p>我们的目标是成为老司机，不要翻车。</p>
<p>好了，大概的思路我们已经捋顺了，现在来说具体怎么做。</p>
<p>前面提到了，我们需要一个引子，具体做法是留出一个标志节点，习惯称为表头(header)。说是节点，其实仅仅是一个指针，没有存放数据的位置。像这样</p>
<p>这里注意一点：表头后的一个单元，叫做头节点，这个节点有数据域，但是也不存有效数据，它仅仅是证明表的存在性。（我初学的时候因为这点没搞透彻，导致代码运行时各种bug，大家要引以为戒啊……）</p>
<p>接下来是代码实现，首先约定一些名字</p>
<div>
<pre class="prettyprint linenums"> struct Node;&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; //先声明一个节点，后面定义
 typedef struct Node *PtrToNode; &nbsp; &nbsp; /*声明节点指针，并且将其类型替换为PtrToNode（替换之前是struct Node*），这样做的目的是方便我们理解*/
 &nbsp;
 &nbsp;
 typedef PtrToNode List; //将struct Node*再次替换为List（表），进一步直观化
 typedef PtrToNode Position;//将struct Node*再次替换为Position(位置）
 &nbsp;
 struct Node{
 &nbsp; &nbsp; int data;
 &nbsp; &nbsp; Position Next;
 };</pre>
</div>
<p>这里的List和Position有什么区别呢？可能很多人会有这个疑问，区别在于，List指表头，Position指某个单元，在后面代码中我们会有更清晰的认识，走吧，咱们继续。</p>
<p>现在我们来一一讨论针对链表的各个操作函数。这里多说一句，关于函数返回值的问题：因为C语言没有bool类型，也就是TRUE和FALSE，所以它用1表示真，0表示假。</p>
<p>（你们不要嫌我啰嗦……）</p>
<p>首先，判断某个表是否为空</p>
<div>
<pre class="prettyprint linenums"> /*如果某个表为空，返回1*/

 int IsEmpty(List L){

     return L-&gt;Next==NULL;//在最后一个单元里，后面是封口的，也就是指针域是NULL

 }</pre>
</div>
<p>我们还需要判断某个表是不是在末尾，这是为了作为循环的终止条件。写法上和判空没什么区别，只是分开写会更方便理解，在完整的代码里我们会感受到的，拭目以待吧。</p>
<div>
<pre class="prettyprint linenums"> &nbsp;
 /*如果P是在表中的末尾位置，返回1*/
 int IsLast(Position P) {
 &nbsp; &nbsp; return P-&gt;Next==NULL;
 }
 &nbsp;</pre>
</div>
<p>这些小零碎写完之后，我们就需要把大的零件写出来了（看吧，在咱们这个领域，要搞一件工程，无论说创造零件还是拼装零件，只需要智力加持，代码就会从手中滑落而出，是不是很优雅2333）</p>
<p>对于大部分线性结构，我们要做的操作大体上分为：增加，删除，查找，遍历这四种，我们先写查找，因为这是删除的基础。为什么删除之前要先查找呢？两个原因，1.我们一般是告诉系统要删除的某个“数据”，也就是节点里data的值，所以要先找到这个值所在的节点是哪个，2.因为这是单链表，如果不拿到要删除元素的前驱，我们可能会丢失整个表。</p>
<p>删除有一个很重要的步骤是释放内存，用free函数，我们刚开始学可能会想当然，觉得直接找到那个元素，然后free一下就好了，那就会造成后面的表全部丢失，这是灾难性的后果。</p>
<p>来写一个查找前驱的函数，它返回一个前驱，假如我们给一个3，他就返回3前面那个表的位置，上面说的原因2决定了写这个函数的必要性，而原因1决定了这个函数还需要一个int型参数。</p>
<div>
<pre class="prettyprint linenums"> Position FindPrevious(int X,List L){

     Position P;                 //声明一个节点指针，并指向头节点（和表头一样）

          P=L;

 　　  while (P!=NULL &amp;&amp; P-&gt;Next-&gt;data!=X) { //P没有走到末尾，同时还没找到给定的X时

         P=P-&gt;Next;                  //P向后走

       }           //走到这一步时，说明要么没找到，P=NULL（结尾处），要么找到了，P=前驱的位置

     return P;

 }</pre>
</div>
<p>第二行用到“与（&amp;&amp;）”操作走了捷径，也就是说，如果“与”运算前半部分为假，结果就自动为假，后半部分不再执行，也就是短路操作，咱们上学期讲过。</p>
<p>按逻辑来说，应该紧接着写删除函数的，正好和FindPrevious相配。但是我想强调一个重要的点，一会再说删除，先说查找函数，这个和上面的区别是：这个返回”当前位置“，上面那个返回”前一个位置“。</p>
<div>
<pre class="prettyprint linenums"> Position Find(int X,List L) {

     Position P;

     P=L-&gt;Next;      //和上面对比一下，区别在哪？

     while (P!=NULL &amp;&amp; X!=P-&gt;data) {

         P=P-&gt;Next;

     }

     return P;

 }</pre>
</div>
<p>这个大体思路和上面一样，但有一个要点，这个函数的起始位置在第一个有效元素，比查找前驱的函数靠后一位，原因好理解吧，这个要查找当前位置，而不是前一个，所以从L-&gt;Next开始。</p>
<p>好了，我们该说删除操作了</p>
<div>
<pre class="prettyprint linenums"> void Delete(int X,List L) {

     Position P,Temp;        //申请两个节点，一个用作拉住前驱，一个用作临时变量

     P=FindPrevious(X, L);   //用P拉住X的前驱

     if (!IsLast(P)) {       //确定P不是末尾，否则没法删除（末尾后面什么也没有）

     Temp=P-&gt;Next;       //用临时指针拉住当前位置，以便后面直接越过这个节点

     P-&gt;Next=Temp-&gt;Next; //当前节点的前驱直接指向后继，绕过了当前节点

     free(Temp);         //释放当前节点内存

     Temp-&gt;Next=NULL;    //将当前节点的指针“收回来”，脑补一下飞机起落架。

     }

 }</pre>
</div>
<p>这里面有两个我想说的地方</p>
<ul><li>9,11行用了一个临时指针，是为了怕大家绕晕，其实也可以写成P-&gt;Next=P-&gt;Next-&gt;Next; 不过这样一来就不好理解了，肯定一堆人默默吐槽两个Next是什么鬼啊。</li>
<li>第15行貌似教材里没有，但这是为了防止出现野指针。</li></ul>
<p>下面我们说插入函数，分为从前插入和从后插入，emmmm好污的感觉（捂脸），向前插入的一个特点是，表头位置不变，而向后插入需要不断更新Position。</p>
<p>先说从前插入，分为三步：</p>
<ul><ul><ol><li>打开冰箱</li>
<li>把大象放进去</li>
<li>关上冰箱</li></ol></ul></ul>
<p>（划掉）</p>
<p>其实是：</p>
<ul><ul><ol><li>分配内存</li>
<li>向后链接</li>
<li>向前链接</li></ol></ul></ul>
<div>
<pre class="prettyprint linenums"> void InsertBefore(int X,Position P){

     Position NewNode;            //用一个临时变量，用以“拴住”新单元

     NewNode=(List)malloc(sizeof(struct Node));  //申请内存，List相当于struct Node*

     NewNode-&gt;data=X;              //将数据填入新单元

     NewNode-&gt;Next=P-&gt;Next;        //与后方单元相连

     P-&gt;Next=NewNode;              //与前方单元相连，这两行顺序不能反，原因…你们试试就知道了

 }</pre>
</div>
<p>是这个样子</p>
<p><img referrerpolicy="no-referrer"src="http://images2017.cnblogs.com/blog/1262741/201710/1262741-20171023211649676-1939696920.gif"></p>
<p>这种情况数组的元素是逆序的。</p>
<p>再说向后插入</p>
<div>
<pre class="prettyprint linenums"> void PushBack(int X,Position P) {

     Position NewNode;       //声明一个新的节点指针

     NewNode=(Position)malloc(sizeof(struct Node));//分配内存

     NewNode-&gt;Next=NULL;     //新节点指针域封闭

     NewNode-&gt;data=X;        //数据装填

     while(!IsLast(P))       //通过循环走到整个链表的末尾

         P=P-&gt;Next;

     P-&gt;Next=NewNode;        //将新节点的地址交给原链表末尾，从尾部链接。

 }</pre>
</div>
<p>这个更容易理解。</p>
<p>再写一个遍历函数，用于打印所有的元素</p>
<div>
<pre class="prettyprint linenums"> void Traverse(List L){

     while (L-&gt;Next!=NULL) {

         printf("%d ",L-&gt;Next-&gt;data);

         L=L-&gt;Next;

     }

     printf("\n");</pre>
</div>
<p>下面是用于演示的主程序，根据自己的需要随意往里面增减部件吧</p>
<div>
<pre class="prettyprint linenums"> int main(){

     int i;

     List L=(List)malloc(sizeof(struct Node));

     L-&gt;Next=NULL;

     printf("Input amount of lists\n");

     scanf("%d",&amp;i);

     while (i--) {

         int n;

         scanf("%d",&amp;n);

         PushBack(n, L);

     }

     Traverse(L);

     printf("Which item would you like to remove?\n");

     scanf("%d",&amp;i);

     Delete(i, L);

     printf("\n");

     printf("The current linked lists are : ");

     Traverse(L);

 }</pre>
</div>
<p>其实每个程序员都是魔法师,程序和算法就是现代的魔法，努力修炼自己的法术吧。</p>
<p>下一篇写游标实现。</p>
<p>p.s.为了方便大家理解，我会在每一行代码后面写注释</p>
<p>pp.s 数据结构是不依赖于具体实现的，所以教科书里用一般性的ElemType表示数据类型，我这里简单起见，全部用int表示</p>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/5qxzd3j8.html">分享几个asp&period;net开发中的小技巧</a>
		</li>
						<li><a href="https://www.batexi.com/a/xq4x1jn8.html">在ubuntu 14&period;04 64位系统上安装32位库</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn1y7z38.html">JAVA调用易信接口向指定好友推送消息（二）POST测试</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn1orz28.html">&lpar;Stack&rpar;Basic Calculator I &amp;amp&semi;&amp;amp&semi; II</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j0wrvlq.html">DropDownList 绑定数据后  插入一条不属于表中的数据</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1kvdz59.html">php笔记&lpar;七&rpar;PHP类于对象之多态</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1kdkp59.html">Coursera课程 Programming Languages&comma; Part A 总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kpyrd39.html">web中的&mdash;&mdash;作者也不知道这里面写的啥</a>
		</li>
						<li><a href="https://www.batexi.com/a/96p6vlj8.html">Angular4 组件间通讯</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdwde2v9.html">c&num;两个listbox怎么把内容添加到另外个listbox</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7o3jzg8.html">Junit测试用例</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyyjzjxq.html">如何合并ts文件&quest;</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2k5ldxq.html">码字工作者的发文姿势&mdash;&mdash; 用MWeb&plus;Markdown Here&plus;七牛 轻松实现多平台发布</a>
		</li>
						<li><a href="https://www.batexi.com/a/qx2oxez8.html">Android灯光系统--通知灯深入分析</a>
		</li>
						<li><a href="https://www.batexi.com/a/9021vv3q.html">C&num;实体对象序列化成Json，并让字段的首字母小写</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jmr13w9.html">DevExpress学习02&mdash;&mdash;DevExpress 14&period;1的汉化</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxl2w5vq.html">Bootstrap Multiselect</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxlyr5zq.html">CentOS7上elasticsearch5&period;5启动报错</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnd4wv38.html">hihocoder 后缀自动机四&amp;&num;183&semi;重复旋律6</a>
		</li>
						<li><a href="https://www.batexi.com/a/96mnnmn8.html">swagger2使用日志</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/q1kyn059.html">CustomDialog&mdash;&mdash;一个多功能、通用、可自定义的Dialog</a>
			</li>
						<li><a href="https://www.batexi.com/a/8ey3koj9.html">【译】The Accidental DBA：SQL Server Backup</a>
			</li>
						<li><a href="https://www.batexi.com/a/qljw03k9.html">Apache Spark 2&period;2&period;0 中文文档 - Spark Streaming 编程指南 &vert; ApacheCN</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1ky6209.html">循环语句for&comma;while&comma;until&comma;select</a>
			</li>
						<li><a href="https://www.batexi.com/a/90m4xwo8.html">CSS3 animation-timing-function steps&lpar;&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwjng5k8.html">Spark任务流程笔记</a>
			</li>
						<li><a href="https://www.batexi.com/a/8zo6wr1q.html">Go语言备忘录：基本数据结构</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnjgp328.html">ClassLoader类加载机制&amp;amp&semi;&amp;amp&semi;JVM内存管理</a>
			</li>
						<li><a href="https://www.batexi.com/a/8oj3z25q.html">bzoj3624（铺黑白路）（并查集维护）</a>
			</li>
						<li><a href="https://www.batexi.com/a/8ey3dme9.html">SQL Server 后悔药  delete drop update</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
